<?

class DimbalSocialSharing{

	public static function buildAllSocialBoxes($options){
		$html = "";
		$html .= self::buildSocialBox(array_merge($options,array("sn"=>'facebook')));
		$html .= self::buildSocialBox(array_merge($options,array("sn"=>'pinterest')));
		$html .= self::buildSocialBox(array_merge($options,array("sn"=>'twitter')));
		$html .= self::buildSocialBox(array_merge($options,array("sn"=>'google')));
		$html .= self::buildSocialBox(array_merge($options,array("sn"=>'reddit')));
		$html .= self::buildSocialBox(array_merge($options,array("sn"=>'digg')));
		$html .= self::buildSocialBox(array_merge($options,array("sn"=>'stumbleupon')));
		return $html;
	}

	public static function buildSocialBox($options){
	
		$defaults = array(
			"sn"=>"facebook",
			"title"=>"",
			"description"=>"",
			"url"=>"",
			"img"=>"",
			"button"=>"dimbal_social_sharing_button_small"
		);
		$options = array_merge($defaults,$options);
		
		//Make sure the text is safe for use in JS
		$options['title'] = htmlentities($options['title']);
		$options['description'] = htmlentities($options['description']);
		
		$html = '';
		switch($options['sn']){
			case 'facebook':
				$html = '<div class="dimbal_social_sharing_container">
					<div class="dimbal_social_sharing_button '.$options['button'].'" onclick="javascript:window.open(\'http://www.facebook.com/sharer.php?t='.$options['title'].'&u='.$options['url'].'\', \'\', \'menubar=no,toolbar=no,resizable=yes,scrollbars=yes,height=500,width=800\');"><img src="'.plugins_url( 'social-icons-16/social_facebook_box_blue_16.png' , __FILE__ ).'" alt="Share on Facebook" /> Share</div>
				</div>';
				break;
			case 'facebook-like-box':
				$html = '<div class="dimbal_social_sharing_container"><div class="fb-like" data-href="'.$options['url'].'" data-send="false" data-layout="box_count" data-show-faces="true" data-width="400"></div></div>';
				break;
			case 'facebook-like-large':
				$html = '<div class="dimbal_social_sharing_container"><div class="fb-like" data-href="'.$options['url'].'" data-send="false" data-show-faces="true" data-width="350"></div></div>';
				break;
			case 'facebook-like':
				$html = '<div class="dimbal_social_sharing_container"><div class="fb-like" data-href="'.$options['url'].'" data-send="false" data-layout="button_count" data-width="25" data-show-faces="false"></div></div>';
				break;
			case 'facebook-js':
				$html = '<div class="dimbal_social_sharing_container">
					<div class="dimbal_social_sharing_button '.$options['button'].'" onclick="javascript:fbPublishFeed(\''.$options['title'].'\',\''.$options['description'].'\', \''.$options['url'].'\',\''.$options['img'].'\');"><img src="'.plugins_url( 'social-icons-16/social_facebook_box_blue_16.png' , __FILE__ ).'" alt="Share on Facebook" /> Share</div>
				</div>';
				break;
			case 'google':
				$html = '<div class="dimbal_social_sharing_container">
					<div class="dimbal_social_sharing_button '.$options['button'].'" onclick="javascript:window.open(\'https://plus.google.com/share?hl=en-US&url='.$options['url'].'\', \'\', \'menubar=no,toolbar=no,resizable=yes,scrollbars=yes,height=500,width=800\');"><img src="'.plugins_url( 'social-icons-16/gplus-16.png' , __FILE__ ).'" alt="Share on Google Plus" /> Share</div>
				</div>';
				break;
			case 'google-button':
				$html = '<div class="dimbal_social_sharing_container"><div class="g-plusone" data-size="tall" href="'.$options['url'].'"></div></div>';
				break;
			case 'twitter':
				$html = '<div class="dimbal_social_sharing_container">
					<div class="dimbal_social_sharing_button '.$options['button'].'" onclick="javascript:window.open(\'https://twitter.com/share?text='.$options['title'].'&url='.$options['url'].'\', \'\', \'menubar=no,toolbar=no,resizable=yes,scrollbars=yes,height=500,width=800\');"><img src="'.plugins_url( 'social-icons-16/social_twitter_box_blue_16.png' , __FILE__ ).'" alt="Share on Twitter" /> Tweet</div>
				</div>';
				break;
			case 'twitter-button':
				$html = '<div class="dimbal_social_sharing_container"><div class="twitter_box"><span id="followers"></span></div>
<a href="https://twitter.com/Snitchware" class="twitter-follow-button" data-show-count="false" data-show-screen-name="false"></a>
<script>!function(d,s,id){var js,fjs=d.getElementsByTagName(s)[0];if(!d.getElementById(id)){js=d.createElement(s);js.id=id;js.src="//platform.twitter.com/widgets.js";fjs.parentNode.insertBefore(js,fjs);}}(document,"script","twitter-wjs");</script></div>';
				break;
			case 'reddit':
				$html = '<div class="dimbal_social_sharing_container">
					<div class="dimbal_social_sharing_button '.$options['button'].'" onclick="javascript:window.open(\'http://www.reddit.com/submit?title='.$options['title'].'&url='.$options['url'].'\', \'\', \'menubar=no,toolbar=no,resizable=yes,scrollbars=yes,height=800,width=900\');"><img src="'.plugins_url( 'social-icons-16/social_reddit_box_16.png' , __FILE__ ).'" alt="Share on Reddit" /> Reddit</div>
				</div>';
				break;
			case 'digg':
				$html = '<div class="dimbal_social_sharing_container">
					<div class="dimbal_social_sharing_button '.$options['button'].'" onclick="javascript:window.open(\'http://digg.com/submit?title='.$options['title'].'&url='.$options['url'].'\', \'\', \'menubar=no,toolbar=no,resizable=yes,scrollbars=yes,height=600,width=900\');"><img src="'.plugins_url( 'social-icons-16/social_digg_box_16.png' , __FILE__ ).'" alt="Share on Digg" /> Digg</div>
				</div>';
				break;
			case 'stumbleupon':
				$html = '<div class="dimbal_social_sharing_container">
					<div class="dimbal_social_sharing_button '.$options['button'].'" onclick="javascript:window.open(\'http://www.stumbleupon.com/submit?title='.$options['title'].'&url='.$options['url'].'\', \'\', \'menubar=no,toolbar=no,resizable=yes,scrollbars=yes,height=600,width=900\');"><img src="'.plugins_url( 'social-icons-16/social_stumbleupon_box_color_16.png' , __FILE__ ).'" alt="Share on StumbleUpon" /> Stumble</div>
				</div>';
				break;
			case 'pintrest':
				$html = '<div class="dimbal_social_sharing_container">
					<div class="dimbal_social_sharing_button '.$options['button'].'" onclick="javascript:window.open(\'http://pinterest.com/pin/create/button/?title='.$options['title'].'&media='.$options['img'].'&description='.$options['description'].'&url='.$options['url'].'\', \'\', \'menubar=no,toolbar=no,resizable=yes,scrollbars=yes,height=600,width=900\');"><img src="'.plugins_url( 'social-icons-16/pinterest-16.png' , __FILE__ ).'" alt="Add to Pinterest" /> PinIt</div>
				</div>';
				break;
		}
		return $html;
	}

}