document.addEventListener('DOMContentLoaded', function() {
	dimbal_popup_init();
}, false);


var dimbal_popup_init = function(){

	var popup_wrapper = document.getElementById("dimbal_popup_wrapper");
	var popup_container = document.getElementById("dimbal_popup_container");

	var dp_cooldown_minutes = popup_container.getAttribute("dp_cooldown_minutes");
	var dp_initial_delay = popup_container.getAttribute("dp_initial_delay");
	var dp_fade_in_delay = popup_container.getAttribute("dp_fade_in_delay");
	var dp_fade_out_delay = popup_container.getAttribute("dp_fade_out_delay");
	var dp_credit = popup_container.getAttribute("dp_credit");

	if(dimbal_popup_is_undefined_integer(dp_cooldown_minutes)){
		dp_cooldown_minutes = 60;	//mins
	}
	if(dimbal_popup_is_undefined_integer(dp_initial_delay)){
		dp_initial_delay = 1000;	//ms
	}
	if(dimbal_popup_is_undefined_integer(dp_fade_in_delay)){
		dp_fade_in_delay = 500;	//ms
	}
	if(dimbal_popup_is_undefined_integer(dp_fade_out_delay)){
		dp_fade_out_delay = 250;	//ms
	}
	
	dp_cooldown_milliseconds = dp_cooldown_minutes * 60 * 1000;  //Turn it into milliseconds
	
	//dp_cooldown_milliseconds = 1; //force a pop each time;
	
	var cookie_name = "dpprompt";
	var now = new Date().getTime();	
	var show_prompt = false;	
	var last_prompt=dimbal_popup_get_cookie(cookie_name);
	
	//console.log("dp_cooldown_minutes ("+dp_cooldown_minutes+") dp_cooldown_milliseconds ("+dp_cooldown_milliseconds+") dp_initial_delay ("+dp_initial_delay+") dp_fade_in_delay ("+dp_fade_in_delay+") dp_fade_out_delay ("+dp_fade_out_delay+") dp_credit ("+dp_credit+") now ("+now+") last_prompt ("+last_prompt+") show_prompt ("+show_prompt+")");
	
	if (last_prompt==null || last_prompt==""){	//Has not been shown yet -- show now	
		//console.log("Last Prompt is Null or empty -- show prompt");
		show_prompt = true;
	}else{
		try{
			var diff = now - last_prompt;
			//console.log("DIFF = "+diff);
			if(diff > dp_cooldown_milliseconds){
				//console.log("Diff is outside threshold -- show prompt");
				show_prompt = true;
			}
		}catch(err){	//Show the prompt on an error -- this should reset the appropriate vars, etc...
			//console.log("We Caught an Error: "+err.message);
			show_prompt = true;
		}
	}
	
	//console.log("Show Prompt ("+show_prompt+")");
	
	if(show_prompt){
		dimbal_popup_set_cookie(cookie_name,now,dp_cooldown_minutes);
		setTimeout(function(){
			dimbal_popup_fade_in(popup_container, dp_fade_in_delay);
			dimbal_popup_fade_in(popup_wrapper, dp_fade_in_delay, 0.8);
		}, dp_initial_delay)
		
	}	
	
	var new_prompt=dimbal_popup_get_cookie(cookie_name);
	//console.log("OldStamp("+last_prompt+") NewStamp("+new_prompt+") Now("+now+")");
	
};

var dimbal_popup_close = function(element_id, delay){
	if(delay==undefined){
	    delay = 100;
    }
	var dp_popup = document.getElementById(element_id);
	dimbal_popup_fade_out(dp_popup,delay);
}

var dimbal_popup_fade_in = function(element, delay, opacity) {
	if(opacity==undefined){
	    opacity = 1;
    }
    var op = 0.01;  // initial opacity
    var interval = delay/(100*opacity);
    var startTime = Math.round(+new Date()/1000);
    element.style.opacity = op;
    element.style.display = 'block';
    element.style.visibility = 'visible';
    //console.log("About to start Fade In Timer : interval("+interval+") delay("+delay+")");
    var timer = setInterval(function () {
        //console.log("Inside the Fade In Timer Loop STARTING OP("+op+")");
        if (op >= opacity){
            clearInterval(timer);
            var endTime = Math.round(+new Date()/1000);
            //console.log("StartTime("+startTime+") EndTime("+endTime+") Duration("+(endTime-startTime)+")");
        }
        element.style.opacity = op;
        element.style.filter = 'alpha(opacity=' + op * 100 + ")";
        op += 0.01;
        //console.log("Inside the Fade In Timer Loop ENDING OP("+op+")");
    }, interval);
}

var dimbal_popup_fade_out = function(element, delay) {
    var op = 1;  // initial opacity
    var interval = delay/100;
    //var startTime = new Date();
    var timer = setInterval(function () {
    	//console.log("Inside the Fade In Timer Loop STARTING OP("+op+")");
        if (op <= 0.01){
            clearInterval(timer);
            element.style.display = 'none';
            element.style.visibility = 'hidden';
            //var endTime = new Date();
            //console.log("StartTime("+startTime+") EndTime("+endTime+") Duration("+(endTime-startTime)+")");
        }
        element.style.opacity = op;
        element.style.filter = 'alpha(opacity=' + op * 100 + ")";
        op -= 0.01;
    }, interval);
};

var dimbal_popup_set_cookie = function(c_name,value,mins){
	if(mins){
		var date = new Date();
		date.setTime(date.getTime()+(mins*60*1000));
		var expires = "; expires="+date.toGMTString();	
	}else{
		var expires = "";
	}
	var cookie_string = c_name + "=" + value + expires + "; path=/";
	document.cookie=cookie_string;
	var new_cookie = dimbal_popup_get_cookie(c_name);
	//console.log("Cookie Save: c_name("+c_name+") value("+value+") cookie_string("+cookie_string+") new_cookie("+new_cookie+")");
};

var dimbal_popup_get_cookie = function(c_name){
	var c_value = document.cookie;
	var c_start = c_value.indexOf(" " + c_name + "=");
	if (c_start == -1){
		c_start = c_value.indexOf(c_name + "=");
	}
	if (c_start == -1){
		c_value = null;
	}else{
		c_start = c_value.indexOf("=", c_start) + 1;
		var c_end = c_value.indexOf(";", c_start);
		if (c_end == -1){
			c_end = c_value.length;
		}
		c_value = unescape(c_value.substring(c_start,c_end));
	}
	return c_value;
}

var dimbal_popup_is_undefined_text = function(variable){
	if(variable == undefined || variable == "" || variable == null || variable == NaN){
		return true;
	}
	return false;
}

var dimbal_popup_is_undefined_integer = function(variable){
	if(variable == undefined || variable == "" || variable == null || variable == NaN || isNaN(variable)){
		return true;
	}
	return false;
}